ElementScanner7 (Java Platform SE 8 )
Keywords: javax.lang.model.util.ElementScanner7 class
Date: 2016-10-23

compact3
javax.lang.model.util

## Class ElementScanner7<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractElementVisitor6<R,P>
  - - javax.lang.model.util.ElementScanner6<R,P>
    - - javax.lang.model.util.ElementScanner7<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Implemented Interfaces:
    ElementVisitor<R,P>
  Direct Known Subclasses:
    ElementScanner8

      @SupportedSourceVersion(value=RELEASE_7)
      public class ElementScanner7<R,P>
      extends ElementScanner6<R,P>

  A scanning visitor of program elements with default behavior appropriate for the `RELEASE_7` source version. The `visitXYZ` methods in this class scan their component elements by calling `scan` on their enclosed elements, parameters, etc., as indicated in the individual method specifications. A subclass can control the order elements are visited by overriding the `visitXYZ` methods. Note that clients of a scanner may get the desired behavior be invoking `v.scan(e, p)` rather than `v.visit(e, p)` on the root objects of interest.

  When a subclass overrides a `visitXYZ` method, the new method can cause the enclosed elements to be scanned in the default way by calling `super.visitXYZ`. In this fashion, the concrete visitor can control the ordering of traversal over the component elements with respect to the additional processing; for example, consistently calling `super.visitXYZ` at the start of the overridden methods will yield a preorder traversal, etc. If the component elements should be traversed in some other order, instead of calling `super.visitXYZ`, an overriding visit method should call `scan` with the elements in the desired order.

  Methods in this class may be overridden subject to their general contract. Note that annotating methods in concrete subclasses with `@Override` will help ensure that methods are overridden as intended.

  WARNING: The `ElementVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

  When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new element scanner visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

  Since:
    1.7
  See Also:
    `ElementScanner6`, `ElementScanner8`

- - ### Field Summary

    - ### Fields inherited from class javax.lang.model.util.ElementScanner6

      `DEFAULT_VALUE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ElementScanner7()` Constructor for concrete subclasses; uses `null` for the default value.
    `protected` | `ElementScanner7(R defaultValue)` Constructor for concrete subclasses; uses the argument for the default value.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R` | `visitVariable(VariableElement e, P p)` This implementation scans the enclosed elements.

    - ### Methods inherited from class javax.lang.model.util.ElementScanner6

      `scan, scan, scan, visitExecutable, visitPackage, visitType, visitTypeParameter`

    - ### Methods inherited from class javax.lang.model.util.AbstractElementVisitor6

      `visit, visit, visitUnknown`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ElementScanner7

          protected ElementScanner7()

      Constructor for concrete subclasses; uses `null` for the default value.

    - #### ElementScanner7

          protected ElementScanner7(R defaultValue)

      Constructor for concrete subclasses; uses the argument for the default value.
      Parameters:
        `defaultValue` - the default value

  - ### Method Detail

    - #### visitVariable

          public R visitVariable(VariableElement e,
                                 P p)

      This implementation scans the enclosed elements.
      Specified by:
        `visitVariable` in interface `ElementVisitor<R,P>`
      Overrides:
        `visitVariable` in class `ElementScanner6<R,P>`
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of scanning

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2016, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.